package com.loafle.overflow.module.sensor.service;

import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.infra.service.InfraService;
import com.loafle.overflow.module.meta.model.MetaCrawler;
import com.loafle.overflow.module.meta.model.MetaSensorStatus;
import com.loafle.overflow.module.probe.model.Probe;
import com.loafle.overflow.module.probe.service.ProbeService;
import com.loafle.overflow.module.sensor.model.Sensor;
import com.loafle.overflow.module.target.model.Target;
import com.loafle.overflow.spring.AppConfigTest;
import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.Date;
import java.util.List;

/**
 * Created by insanity on 17. 6. 28.
 */
//@Ignore
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class SensorServiceTest {
    @Autowired
    SensorService sensorService;



    @Ignore
    @Test
    public void regist() throws Exception {
        Sensor sensor = new Sensor();
        MetaSensorStatus status = new MetaSensorStatus((short)1);
        sensor.setStatus(status);
        MetaCrawler crawler = new MetaCrawler();
        crawler.setId((short)1);
        sensor.setCrawler(crawler);
        Target target = new Target();
        target.setId(1);
        sensor.setTarget(target);
        sensor.setCreateDate(new Date());

        Sensor res = this.sensorService.regist(sensor);
        Assert.assertNotNull(res);
    }

    @Test
    public void read() throws Exception {
        Sensor res = this.sensorService.read("1");
        Assert.assertNotNull(res);

        ObjectMapper objectMapper = new ObjectMapper();

        String json = objectMapper.writeValueAsString(res);

        System.out.println(json);
    }

    @Test
    public void readAllByTarget() throws Exception {
        Target target = new Target();
        target.setId(1);
        List<Sensor> sensors = this.sensorService.readAllByTarget(target);

        ObjectMapper objectMapper = new ObjectMapper();

        String json = objectMapper.writeValueAsString(sensors);

        System.out.println(json);
    }

    @Test
    public void readAllByTargetList() {

        Domain domain = new Domain();
        domain.setId(1);

        List<Sensor> sl = this.sensorService.readAllByDomain(domain);

        Assert.assertNotEquals(sl.size(), 0);

    }
}
